INCLUDE \masm32\include\masm32rt.inc
.586
INCLUDE \masm32\macros\timers.asm

.data
buf BYTE 30 DUP(0)
val1 DWORD 80000000h

	align 16
chartabL dw "00","10","20","30","40","50","60","70","80","90"
                dw "01","11","21","31","41","51","61","71","81","91"
                dw "02","12","22","32","42","52","62","72","82","92"
                dw "03","13","23","33","43","53","63","73","83","93"
                dw "04","14","24","34","44","54","64","74","84","94"
                dw "05","15","25","35","45","55","65","75","85","95"
                dw "06","16","26","36","46","56","66","76","86","96"
                dw "07","17","27","37","47","57","67","77","87","97"
                dw "08","18","28","38","48","58","68","78","88","98"
                dw "09","19","29","39","49","59","69","79","89","99"

.code
;  

OPTION PROLOGUE:NONE
OPTION EPILOGUE:NONE
;----------------------------------------------------------
;dwtoa2 by brethren using hutchs optimizations from utoa2
;----------------------------------------------------------
ALIGN 16
dwtoa2 PROC value:DWORD, szbuf:PTR BYTE
	push ebx
	push esi

	mov eax, [esp+12]		;value
	mov ebx, 0CCCCCCCDh
	mov esi, [esp+16]		;szbuf

	test eax, eax
	jge @F
	mov BYTE PTR [esi], '-'
	add esi, 1
	neg eax
@@:
	cmp eax, 9999
	ja lb4

	cmp eax, 999999
	ja lb6

	cmp eax, 9
	ja lb1
	add esi, 1
	jmp @F
lb1:
	cmp eax, 99
	ja lb2
	add esi, 2
	jmp @F
lb2:
	cmp eax, 999
	ja lb3
	add esi, 3
	jmp @F
lb3:
	cmp eax, 9999
	ja lb4
	add esi, 4
	jmp @F
lb4:
	cmp eax, 99999
	ja lb5
	add esi, 5
	jmp @F
lb5:
	cmp eax, 999999
	ja lb6
	add esi, 6
	jmp @F
lb6:
	cmp eax, 9999999
	ja lb7
	add esi, 7
	jmp @F
lb7:
	cmp eax, 99999999
	ja lb8
	add esi, 8
	jmp @F
lb8:
	cmp eax, 999999999
	ja lb9
	add esi, 9
	jmp @F
lb9:
	add esi, 10
@@:
	mov BYTE PTR [esi], NULL
	sub esi, 1
@@:	;loop unrolled twice
	mov ecx, eax
	mul ebx
	shr edx, 3
	mov eax, edx
	lea edx, [edx+edx*4]
	lea edx, [edx+edx-'0']
	sub ecx, edx
	mov [esi], cl
	sub esi, 1
	test eax, eax
	jbe done

	mov ecx, eax
	mul ebx
	shr edx, 3
	mov eax, edx
	lea edx, [edx+edx*4]
	lea edx, [edx+edx-'0']
	sub ecx, edx
	mov [esi], cl
	sub esi, 1
	test eax, eax
	ja @B
done:
	pop esi
	pop ebx
	ret 8
dwtoa2 ENDP

;----------------------------------------------------------
;dwtoa2 by brethren using hutchs optimizations from utoa2
;----------------------------------------------------------
align 16
;u32toalin by lingo
db  15 Dup (0)
dwtoa3Lin  PROC value:DWORD, szbuf:PTR BYTE
	pop     edx	        	
	pop     eax           
	pop     ecx   
	test		eax, eax
	jge		@f
	mov		byte ptr [ecx], '-'
	neg		eax
	add		ecx, 1
@@:
	cmp     eax, 99999              
	jbe      L4	
	cmp     eax, 9999999        
	push   edx				
	jbe		L2
	cmp     eax, 999999999    
    push   ebx 	
	ja        L8
	cmp    eax, 99999999     
	ja       L1	
	add    ecx, 8					 	
	push  esi    
	jne     L9
L1 :
	add     ecx, 9
	push   esi							
	jne      L9
L2:
	cmp    eax, 999999         
	push  ebx
	ja        L3	
	add    ecx, 6
	push  esi							
	jne     L9
L3:
	add     ecx, 7
	push   esi							
	jne      L9
L4:	
	cmp    eax, 999              
	push   edx        
	jbe      L6
	cmp    eax, 9999              	
	push   ebx
	ja         L5
	add    ecx, 4
	push   esi							
	jne      L9
L5:
	add     ecx, 5
	push   esi							
	jne      L9
L6:
	cmp    eax, 99			            
	push   ebx
	jbe     L7
	add    ecx, 3
	push   esi							
	jne     L9
L8:
	push   esi    
	add    ecx, 10
L9:
	mov    byte ptr [ecx], 0
	mov    esi,  0CCCCCCCDh
@@:
    mov	ebx, eax
    mul	esi
    shr	edx, 3
    sub	ecx, 1
    mov	eax, edx
    lea	edx, [edx+edx*4-18h]
    lea	edx, [edx+edx]
    sub	ebx, edx
    mov	[ecx], bl
    test  eax, eax
    je     @f

    mov	ebx, eax
    mul	esi
    shr	edx, 3
    sub	ecx, 1
    mov	eax, edx
    lea	edx, [edx+edx*4-18h]
    lea	edx, [edx+edx]
    sub	ebx, edx
    mov	[ecx], bl
    test eax, eax
    jne  @b
@@:
    pop	esi	
    mov	eax, ecx
    pop	ebx 
    ret 	
L7:
    cmp     eax, 9			           
    push    esi
    jbe     L10
    add     ecx, 2                     
    jne     L9
L10:
    add eax, 30h              
    pop	esi	
    mov	[ecx],  ax
    pop	ebx 
    mov	eax, ecx
    ret 
dwtoa3Lin ENDP


align 16
;sdwtoa_exLin optimized by lingo
sdwtoa_exLin  PROC value:DWORD, szbuf:PTR BYTE
	mov    eax,	[esp+1*4]		     
	mov	    edx,	0D1B71759h	     
 	mov	    ecx,	[esp+2*4]		     
	test		eax, eax
	jge		@f
	mov		byte ptr [ecx], '-'
	add		ecx, 1
	neg		eax
@@:
	mov	  [esp+1*4], edi		    	
	mov	  edi,	eax						
	mov   [esp+2*4], esi		    	
 	mul	  edx								
	shr	  edx,	13						
	mov	  esi,	100	
	je		  LoNext3				 	    
	imul	  eax,	edx, 10000	
	sub	  edi,	eax
	mov	  eax,	68DB9h		    	
	mul	  edx		
	jnc	  LoNext1	
	cmp	  edx,	9	
	jbe     Lo0
	movzx	edx,	word ptr chartabL[edx+edx]	 
	add    ecx, 8      
	mov   [ecx-8], edx
Lo1:				
	mul	esi	 
Lo1a:			
	movzx	edx,	word ptr chartabL[edx+edx]	 
	mov	[ecx-6], edx	 
Lo2:				
	mul	esi		 
Lo2a:				
	movzx	edx,	word ptr chartabL[edx+edx]	 
	mov	[ecx-4], edx	 
Lo3:				
	mov	eax,	28F5C29h	 
	mul	edi		 
Lo3a:				
	movzx	edx,	word ptr chartabL[edx+edx]	 
	mov	[ecx-2], edx	 
Lo4:				
	mul	esi		 
Lo4a:				
	movzx	eax,	 word ptr chartabL[edx+edx]	 
	pop	 edx		
	mov	[ecx], 	eax	 
	pop	edi	
	lea	eax,	[ecx+2]	
	pop	esi		
	jmp	edx
Lo0:										
    add	ecx,	7
	add	edx,	30h	
	mov	[ecx-7],  edx	
	jne	Lo1	
LoNext1:			
	mul	esi		 
	jnc	@f		 
	add	ecx, 6	
	cmp	edx,	9	 
	ja		Lo1a		 
	add	edx,	30h	
	sub	ecx,	1	 
	mov	[ecx-5],  edx	 
	jnz	Lo2		 
@@:				
	mul	esi		 
	jnc	LoNext3		 
	add	ecx, 	4	
	cmp	edx,	9	
	ja		Lo2a		 
	add	edx,	30h	
	sub	ecx,	1	 
	mov	[ecx-3],  edx	 
	jnz	Lo3		 
LoNext3:			
	mov	eax,	28F5C29h 
	mul	edi		 
	jnc	@f		 
	add	ecx, 	2	
	cmp	edx,	9	 
	ja		Lo3a		 
	add	edx,	30h	
	sub	ecx,	1	 
	mov	[ecx-1],   edx	 
	jnz	Lo4		 
@@:				
	mul	esi		 
	cmp	edx,	9	 
	ja		Lo4a	 
	lea	eax, [edx+30h]
	pop	edx
	mov	[ecx], 	eax	
	pop	edi
	lea	eax,	[ecx+1]	
	pop	esi
	jmp	edx
sdwtoa_exLin ENDP

OPTION PROLOGUE:PrologueDef
OPTION EPILOGUE:EpilogueDef
;----------------------------------------------------------
main PROC
	counter_begin 10000000, HIGH_PRIORITY_CLASS
		INVOKE dwtoa, val1, ADDR buf
	counter_end
	print ustr$(eax)
	print chr$(" cycles for dwtoa-masmlib",13,10)

	counter_begin 10000000, HIGH_PRIORITY_CLASS
		INVOKE dwtoa2, val1, ADDR buf
	counter_end
	print ustr$(eax)
	print chr$(" cycles for dwtoa2-brethren",13,10)

	counter_begin 10000000, HIGH_PRIORITY_CLASS
		INVOKE dwtoa3Lin, val1, ADDR buf
	counter_end
	print ustr$(eax)
	print chr$(" cycles for dwtoa3-Lingo",13,10)


	counter_begin 10000000, HIGH_PRIORITY_CLASS
		INVOKE sdwtoa_exLin, val1, ADDR buf
	counter_end
	print ustr$(eax)
	print chr$(" cycles for sdwtoa_ex-Lingo",13,10)

	inkey "--test finished--"
	exit
main ENDP
END main


